"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
const Utils = __importStar(require("../../utils"));
/**
 * ユーザーが利用できる各種変換オプション
 */
const create = () => {
    const convertReservedWord = (word) => {
        if (["import", "export"].includes(word)) {
            return word + "_";
        }
        return word;
    };
    const convertString = (text) => {
        if (Utils.isAvailableVariableName(text)) {
            return text;
        }
        return text.replace(/-/g, "$").replace(/\//g, "$");
    };
    return {
        escapeOperationIdText: (operationId) => {
            return convertString(operationId);
        },
        escapeDeclarationText: (text) => {
            return convertReservedWord(convertString(text));
        },
        escapePropertySignatureName: (text) => {
            return Utils.escapeText(text);
        },
        escapeTypeReferenceNodeName: (text) => {
            return convertString(text);
        },
        generateResponseName: (operationId, statusCode) => {
            return Utils.responseName(convertString(operationId), statusCode);
        },
        generateArgumentParamsTypeDeclaration: (operationId) => {
            return Utils.argumentParamsTypeDeclaration(convertString(operationId));
        },
        generateRequestContentTypeName: (operationId) => {
            return Utils.requestContentType(convertString(operationId));
        },
        generateResponseContentTypeName: (operationId) => {
            return Utils.responseContentType(convertString(operationId));
        },
        generateParameterName: (operationId) => {
            return Utils.parameterName(convertString(operationId));
        },
        generateRequestBodyName: (operationId) => {
            return Utils.requestBodyName(convertString(operationId));
        },
        generateFunctionName: (operationId) => {
            return convertString(operationId);
        },
    };
};
exports.create = create;
//# sourceMappingURL=ConverterContext.js.map