"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isComponentName = exports.isAnyOfSchema = exports.isAllOfSchema = exports.isOneOfSchema = exports.isObjectSchemaWithAdditionalProperties = exports.isStringArray = exports.isNumberArray = exports.isPrimitiveSchema = exports.isArraySchema = exports.isHasNoMembersObject = exports.isObjectSchema = exports.isUnSupportSchema = exports.isReference = void 0;
const isReference = (data) => {
    if (typeof data !== "object" || data === null) {
        return false;
    }
    return typeof data.$ref === "string";
};
exports.isReference = isReference;
const isUnSupportSchema = (schema) => {
    return Array.isArray(schema.type);
};
exports.isUnSupportSchema = isUnSupportSchema;
const isObjectSchema = (schema) => {
    return schema.type === "object";
};
exports.isObjectSchema = isObjectSchema;
const isHasNoMembersObject = (schema) => {
    return Object.keys(schema).length === 0;
};
exports.isHasNoMembersObject = isHasNoMembersObject;
const isArraySchema = (schema) => {
    return schema.type === "array";
};
exports.isArraySchema = isArraySchema;
const isPrimitiveSchema = (schema) => {
    if (typeof schema.type !== "string") {
        return false;
    }
    if (schema.type === "object") {
        return false;
    }
    if (schema.type === "array") {
        return false;
    }
    return true;
};
exports.isPrimitiveSchema = isPrimitiveSchema;
const isNumberArray = (list) => {
    return !list.some(item => typeof item !== "number");
};
exports.isNumberArray = isNumberArray;
const isStringArray = (list) => {
    return !list.some(item => typeof item !== "string");
};
exports.isStringArray = isStringArray;
const isObjectSchemaWithAdditionalProperties = (schema) => {
    return !!schema.additionalProperties;
};
exports.isObjectSchemaWithAdditionalProperties = isObjectSchemaWithAdditionalProperties;
const isOneOfSchema = (schema) => {
    return !!schema.oneOf && typeof schema.oneOf !== "boolean" && Array.isArray(schema.oneOf);
};
exports.isOneOfSchema = isOneOfSchema;
const isAllOfSchema = (schema) => {
    return !!schema.allOf && typeof schema.allOf !== "boolean" && Array.isArray(schema.allOf);
};
exports.isAllOfSchema = isAllOfSchema;
const isAnyOfSchema = (schema) => {
    return !!schema.anyOf && typeof schema.anyOf !== "boolean" && Array.isArray(schema.anyOf);
};
exports.isAnyOfSchema = isAnyOfSchema;
const isComponentName = (name) => {
    return ["schemas", "headers", "responses", "parameters", "requestBodies", "securitySchemes", "pathItems"].includes(name);
};
exports.isComponentName = isComponentName;
//# sourceMappingURL=Guard.js.map