"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.create = void 0;
const os_1 = require("os");
const httpMethodList = ["get", "put", "post", "delete", "options", "head", "patch", "trace"];
const create = (rootSchema) => {
    const paths = rootSchema.paths || {};
    const state = {};
    Object.entries(paths).forEach(([requestUri, pathItem]) => {
        httpMethodList.forEach(httpMethod => {
            const operation = pathItem[httpMethod];
            if (!operation) {
                return;
            }
            if (!operation.operationId) {
                return;
            }
            state[operation.operationId] = {
                httpMethod,
                requestUri,
                comment: [operation.summary, operation.description].filter(Boolean).join(os_1.EOL),
                deprecated: !!operation.deprecated,
                requestBody: operation.requestBody,
                parameters: operation.parameters,
                responses: operation.responses,
            };
        });
    });
    return state;
};
exports.create = create;
//# sourceMappingURL=Operation.js.map