import ts from "typescript";
import { generateComment } from "./utils";
export const create = ({ factory }) => (params) => {
    const node = factory.createPropertySignature(undefined, params.name, params.optional ? factory.createToken(ts.SyntaxKind.QuestionToken) : undefined, params.type);
    if (params.comment) {
        const comment = generateComment(params.comment);
        return ts.addSyntheticLeadingComment(node, ts.SyntaxKind.MultiLineCommentTrivia, comment.value, comment.hasTrailingNewLine);
    }
    return node;
};
export const make = (context) => {
    return {
        create: create(context),
    };
};
//# sourceMappingURL=PropertySignature.js.map