import ts from "typescript";
import type { TsGenerator } from "../../api";
import type { CodeGenerator } from "../../types";
/**
 * export type RequestContentType${operationId} = keyof RequestBody${operationId};
 */
export declare const createRequestContentTypeReference: (factory: TsGenerator.Factory.Type, { convertedParams }: CodeGenerator.Params) => ts.TypeAliasDeclaration;
/**
 * export type ResponseContentType${operationId} = keyof Response${operationId}$Status$200;
 * export type ResponseContentType${operationId} = keyof Response${operationId}$Status$200 | keyof Response${operationId}$Status$203;
 */
export declare const createResponseContentTypeReference: (factory: TsGenerator.Factory.Type, { convertedParams }: CodeGenerator.Params) => ts.TypeAliasDeclaration;
/**
 * Function Template
 *
 * export interface {name}<T extends keyof {requestBodyName}> {
 *   parameter: {parameterName};
 *   requestBody: {requestBodyName}[T];
 * }
 */
export declare const create: (factory: TsGenerator.Factory.Type, params: CodeGenerator.Params) => ts.InterfaceDeclaration | undefined;
