import type { OpenApi } from "../../types";
import { Def } from "./store";
import * as Types from "./types";
export declare const isReference: (data: any) => data is OpenApi.Reference;
export declare const isUnSupportSchema: (schema: OpenApi.Schema) => schema is Types.UnSupportSchema;
export declare const isObjectSchema: (schema: OpenApi.Schema) => schema is Types.ObjectSchema;
export declare const isHasNoMembersObject: (schema: OpenApi.Schema) => boolean;
export declare const isArraySchema: (schema: OpenApi.Schema) => schema is Types.ArraySchema;
export declare const isPrimitiveSchema: (schema: OpenApi.Schema) => schema is Types.PrimitiveSchema;
export declare const isNumberArray: (list: any[]) => list is number[];
export declare const isStringArray: (list: any[]) => list is string[];
export declare const isObjectSchemaWithAdditionalProperties: (schema: Types.ObjectSchema) => schema is Types.ObjectSchemaWithAdditionalProperties;
export declare const isOneOfSchema: (schema: OpenApi.Schema) => schema is Types.OneOfSchema;
export declare const isAllOfSchema: (schema: OpenApi.Schema) => schema is Types.AllOfSchema;
export declare const isAnyOfSchema: (schema: OpenApi.Schema) => schema is Types.AnyOfSchema;
export declare const isComponentName: (name: string) => name is Def.ComponentName;
