import ts from "typescript";
import type { OpenApi } from "../../../types";
import { Factory } from "../../TsGenerator";
import * as Def from "./Definition";
import * as Operation from "./Operation";
import * as State from "./State";
import * as Structure from "./structure";
export interface Type {
    addComponent: (componentName: Def.ComponentName, statement: Structure.ComponentParams) => void;
    /**
     * @params path: "components/headers/hoge"
     */
    addStatement: (path: string, statement: Structure.ComponentParams) => void;
    getStatement: <T extends Structure.DataStructure.Kind>(path: string, kind: T) => Structure.DataStructure.GetChild<T> | undefined;
    /**
     * @params path: "components/headers/hoge"
     */
    hasStatement: (path: string, types: Structure.DataStructure.Kind[]) => boolean;
    addAdditionalStatement: (statements: ts.Statement[]) => void;
    getRootStatements: () => ts.Statement[];
    getAdditionalStatements: () => ts.Statement[];
    updateOperationState: (httpMethod: string, requestUri: string, operationId: string, state: Partial<State.OperationState>) => void;
    getNoReferenceOperationState: () => Operation.State;
    getPathItem: (localPath: string) => OpenApi.PathItem;
    isAfterDefined: (referencePath: string) => boolean;
    getParameter: (localPath: string) => OpenApi.Parameter;
}
export declare const create: (factory: Factory.Type, rootDocument: OpenApi.Document) => Type;
