import ts from "typescript";
export interface Params$FindStatement {
    node: ts.ModuleDeclaration;
    name: string;
}
export interface Params$Create {
    export?: true;
    name: string;
    statements: ts.Statement[];
    comment?: string;
    deprecated?: boolean;
}
export interface Params$CreateMulti extends Omit<Params$Create, "name"> {
    names: string[];
}
export interface Params$Update {
    node: ts.ModuleDeclaration;
    statements: ts.Statement[];
}
export interface Factory {
    create: (params: Params$Create) => ts.ModuleDeclaration;
    findNamespace: (params: Params$FindStatement) => ts.Statement | undefined;
    createMultiple: (params: Params$CreateMulti) => ts.ModuleDeclaration;
    update: (params: Params$Update) => ts.ModuleDeclaration;
    addStatements: (params: Params$Update) => ts.ModuleDeclaration;
}
export declare const findStatement: (context: Pick<ts.TransformationContext, "factory">) => Factory["findNamespace"];
export declare const create: ({ factory }: Pick<ts.TransformationContext, "factory">) => Factory["create"];
export declare const createMultiple: (context: Pick<ts.TransformationContext, "factory">) => Factory["createMultiple"];
export declare const update: (context: Pick<ts.TransformationContext, "factory">) => Factory["update"];
export declare const addStatements: (context: Pick<ts.TransformationContext, "factory">) => Factory["addStatements"];
export declare const make: (context: Pick<ts.TransformationContext, "factory">) => Factory;
